package com.koucky.petr.mysldenik;

import android.content.Intent;
import android.content.pm.PackageManager;
import android.location.Location;
import android.net.Uri;
import android.os.Build;
import android.os.Bundle;
import android.support.annotation.NonNull;
import android.support.v4.app.ActivityCompat;
import android.support.v4.app.FragmentTransaction;
import android.support.v4.content.ContextCompat;
import android.support.v4.view.GravityCompat;
import android.support.v4.widget.DrawerLayout;
import android.support.v7.app.ActionBarDrawerToggle;
import android.support.v7.app.AppCompatActivity;
import android.util.Log;
import android.view.Gravity;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.view.View;
import android.view.ViewGroup;
import android.view.animation.Animation;
import android.view.animation.AnimationUtils;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.FrameLayout;
import android.widget.ProgressBar;
import android.widget.RelativeLayout;
import android.widget.Spinner;
import android.widget.TextSwitcher;
import android.widget.TextView;
import android.widget.ViewSwitcher;

import com.google.android.gms.common.ConnectionResult;
import com.google.android.gms.common.api.GoogleApiClient;
import com.google.android.gms.location.LocationServices;
import com.google.android.gms.location.places.Places;
import com.google.android.gms.maps.CameraUpdateFactory;
import com.google.android.gms.maps.GoogleMap;
import com.google.android.gms.maps.OnMapReadyCallback;
import com.google.android.gms.maps.SupportMapFragment;
import com.google.android.gms.maps.model.BitmapDescriptorFactory;
import com.google.android.gms.maps.model.CameraPosition;
import com.google.android.gms.maps.model.LatLng;
import com.google.android.gms.maps.model.MarkerOptions;
import com.google.firebase.auth.FirebaseAuth;
import com.google.firebase.auth.FirebaseUser;
import com.google.firebase.database.DataSnapshot;
import com.google.firebase.database.DatabaseError;
import com.google.firebase.database.FirebaseDatabase;
import com.google.firebase.database.ValueEventListener;
import com.gordonwong.materialsheetfab.MaterialSheetFab;
import com.gordonwong.materialsheetfab.MaterialSheetFabEventListener;
import com.koucky.petr.mysldenik.entity.Shooting;
import com.koucky.petr.mysldenik.entity.Structure;
import com.koucky.petr.mysldenik.entity.evidence.EvidenceDamages;
import com.koucky.petr.mysldenik.fragments.EvidenceFragment;
import com.koucky.petr.mysldenik.fragments.PlansFragment;
import com.koucky.petr.mysldenik.fragments.UsefulInfoFragment;

import java.util.ArrayList;
import java.util.Calendar;

import static android.Manifest.permission.WRITE_EXTERNAL_STORAGE;
import static android.content.pm.PackageManager.PERMISSION_GRANTED;

public class MainActivity extends AppCompatActivity implements View.OnClickListener,
        PlansFragment.OnFragmentInteractionListener,
        EvidenceFragment.OnFragmentInteractionListener,
        OnMapReadyCallback,
        GoogleApiClient.ConnectionCallbacks,
        GoogleApiClient.OnConnectionFailedListener,
        UsefulInfoFragment.OnFragmentInteractionListener {

    private static final int MY_PERMISSIONS_REQUEST_WRITE_STORAGE = 52;
    private static final int PERMISSIONS_REQUEST_ACCESS_FINE_LOCATION = 1;
    private static final int CAMERA_PERMISSION_REQUEST = 966;
    private final LatLng mDefaultLocation = new LatLng(-53.8523341, 101.2106085);
    private Button btnLogout;
    private FirebaseAuth auth;
    private String year;
    private String uid;
    private String shooting;
    private FirebaseDatabase firebaseDatabase;
    private MaterialSheetFab materialSheetFab;
    private final String TAG = "MainActivity";
    private int statusBarColor;
    private FirebaseAuth.AuthStateListener mAuthListener;
    private ActionBarDrawerToggle drawerToggle;
    private DrawerLayout drawerLayout;
    private SupportMapFragment mapFragment;
    private PlansFragment plansFragment;
    private UsefulInfoFragment usefulInfoFragment;
    private EvidenceFragment evidenceFragment;
    private double mShootingLocationLat = 0;
    private double mShootingLocationLng = 0;
    private GoogleMap mMap;
    private FrameLayout frameLayout;
    private RelativeLayout.LayoutParams layoutParams;
    private ProgressBar progressBar;
    private GoogleApiClient mGoogleApiClient;
    private boolean mLocationPermissionGranted;
    private CameraPosition mCameraPosition;
    private ViewGroup transitionsContainer;
    private TextSwitcher mSwitcher;
    private TextView secondHeaderText;
    private Button buttonLeft;
    private Button buttonRight;
    private Animation inL;
    private Animation outL;
    private Animation inR;
    private Animation outR;

    private String sliderTitles[] = {};
    private String usefulInfoTitles[] = {"dogs","hunts"};
    private String usefulInfoReadableTitles[] = {"Kynologie","Doby lovu zvěře"};
    private String evidenceTitles[] = {"damages","sharedHunts","singleHunts","diseases","shooting"};
    private String evidenceReadableTitles[] = {"Škody způsobené zvěří","Ulovená zvěř lovů hromadných","Ulovená zvěř lovů samostaných","Hlášené choroby","Výživa honitby"};
    private int messageCount;
    // to keep current Index of text
    private int currentIndex=1;

    // Keys for storing activity state.
    private static final String KEY_CAMERA_POSITION = "camera_position";
    private static final String KEY_LOCATION = "location";

    // The geographical location where the device is currently located. That is, the last-known
    // location retrieved by the Fused Location Provider.
    private Location mLastKnownLocation;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        auth = FirebaseAuth.getInstance();
        setContentView(R.layout.activity_main);

        progressBar = (ProgressBar) findViewById(R.id.progressBar);
        progressBar.setVisibility(View.VISIBLE);
        ((TextView) findViewById(R.id.headerTitle)).setText(getString(R.string.shootingMap));

        frameLayout = (FrameLayout) findViewById(R.id.fragment_container);
        layoutParams = (RelativeLayout.LayoutParams) frameLayout.getLayoutParams();

        mSwitcher = (TextSwitcher) findViewById(R.id.textSwitcher);
//        findViewById(R.id.secondHeader).animate().translationX(10);
//        transitionsContainer = (ViewGroup) findViewById(R.id.secondHeader);
//        secondHeaderText = (TextView) findViewById(R.id.secondHeaderText);
        buttonLeft = (Button) findViewById(R.id.buttonLeft);
        buttonRight = (Button) findViewById(R.id.buttonRight);

        mAuthListener = new FirebaseAuth.AuthStateListener() {
            @Override
            public void onAuthStateChanged(@NonNull FirebaseAuth firebaseAuth) {
                FirebaseUser user = firebaseAuth.getCurrentUser();
                if (user != null) {
                    // User is signed in
                    Log.d(TAG, "onAuthStateChanged:signed_in:" + user.getUid());
                } else {
                    // User is signed out
                    startActivity(new Intent(MainActivity.this, LogInActivity.class));
                    finish();
                }
            }
        };

        final ArrayList<String> years = new ArrayList<>();
        int thisYear = Calendar.getInstance().get(Calendar.YEAR);
        for (int i = 2016; i <= thisYear; i++) {
            years.add(Integer.toString(i));
        }
        ArrayAdapter<String> adapter = new ArrayAdapter<>(this, android.R.layout.simple_spinner_item, years);

        final Spinner spinYear = (Spinner)findViewById(R.id.yearSpinner);
        spinYear.setAdapter(adapter);
        spinYear.setOnItemSelectedListener(new AdapterView.OnItemSelectedListener() {
            @Override
            public void onItemSelected(AdapterView<?>parent, View view, int arg2, long arg3) {
                year = spinYear.getSelectedItem().toString();
                if(evidenceFragment != null && evidenceFragment.isAdded()) {
                    evidenceFragment.clearEvidences();
                    evidenceFragment.setAdapter();
                }
            }

            @Override
            public void onNothingSelected(AdapterView<?> arg0) {
                // TODO Auto-generated method stub

            }
        });

        firebaseDatabase = FirebaseDatabase.getInstance();
        //TODO neco na budouci implementaci - offline persistance
//        firebaseDatabase.setPersistenceEnabled(true);

        uid = FirebaseAuth.getInstance().getCurrentUser() != null ? FirebaseAuth.getInstance().getCurrentUser().getUid() : null;
        firebaseDatabase.getReference("shootings/" + uid).addListenerForSingleValueEvent(new ValueEventListener() {

            @Override
            public void onDataChange(DataSnapshot snapshot) {
                for (DataSnapshot child : snapshot.getChildren()) {
                    if (child.getValue(Shooting.class).active) {
                        shooting = child.getKey();
                        mShootingLocationLat = child.getValue(Shooting.class).lat;
                        mShootingLocationLng = child.getValue(Shooting.class).lng;
                        System.out.println(shooting);
                        if (mMap != null) {
                            getDeviceLocation();
                        }

                        mGoogleApiClient = new GoogleApiClient.Builder(MainActivity.this)
                                .enableAutoManage(MainActivity.this /* FragmentActivity */,
                                        MainActivity.this /* OnConnectionFailedListener */)
                                .addConnectionCallbacks(MainActivity.this)
                                .addApi(LocationServices.API)
                                .addApi(Places.GEO_DATA_API)
                                .addApi(Places.PLACE_DETECTION_API)
                                .build();
                        mGoogleApiClient.connect();



                        firebaseDatabase.getReference("structures/" + uid + "/" + shooting).addListenerForSingleValueEvent(new ValueEventListener() {

                            @Override
                            public void onDataChange(DataSnapshot snapshot) {
                                Structure krmelecMarker;
                                Structure posedMarker;
                                for (DataSnapshot child : snapshot.getChildren()) {
                                    if (child.getKey().equals("krmelec")) {
                                        for (DataSnapshot krmelec : child.getChildren()) {
                                            krmelecMarker = krmelec.getValue(Structure.class);
                                            mMap.addMarker(new MarkerOptions()
                                                    .position(new LatLng(krmelecMarker.lat, krmelecMarker.lng))
                                                    .title(krmelecMarker.name)
                                                    .icon(BitmapDescriptorFactory.fromResource(R.drawable.ic_krmelec)));
                                        }
                                    }
                                    if (child.getKey().equals("posed")) {
                                        for (DataSnapshot posed : child.getChildren()) {
                                            posedMarker = posed.getValue(Structure.class);
                                            mMap.addMarker(new MarkerOptions()
                                                    .position(new LatLng(posedMarker.lat, posedMarker.lng))
                                                    .title(posedMarker.name)
                                                    .icon(BitmapDescriptorFactory.fromResource(R.drawable.ic_posed)));
                                        }
                                    }
                                }

                                plansFragment = PlansFragment.newInstance("param", "pa");
                                usefulInfoFragment = UsefulInfoFragment.newInstance("ads", "Echo");
                                evidenceFragment = EvidenceFragment.newInstance(
                                        "evidences" + "/" + uid + "/" + shooting + "/" + year + "/damages", "");

                                progressBar.setVisibility(View.INVISIBLE);
                                findViewById(R.id.fab).setVisibility(View.VISIBLE);
                            }

                            @Override
                            public void onCancelled(DatabaseError databaseError) {
                                // Getting Post failed, log a message
                                System.out.println("ASDASD");
                                // ...
                            }
                        });

                        return;
                    }
                }
            }

            @Override
            public void onCancelled(DatabaseError databaseError) {
                // Getting Post failed, log a message
                System.out.println("ASDASD");
                // ...
            }
        });


        setupFab();

        if (auth.getCurrentUser() == null) {
            startActivity(new Intent(MainActivity.this, LogInActivity.class));

        }

    }

    @Override
    public void setSecondHeader() {

    }

    public ProgressBar getProgressBar() {
        return progressBar;
    }

    @Override
    public void onResume() {
        super.onResume();
        System.out.println("Ahoj");
        /*FragmentTransaction ft = getSupportFragmentManager().beginTransaction();
        if (mMap != null && mapFragment.isAdded()) { ft.show(mapFragment); }
        ft.commit();*/
//        getDeviceLocation();
    }

    /**
     * Saves the state of the map when the activity is paused.
     */
    @Override
    protected void onSaveInstanceState(Bundle outState) {
        if (mMap != null) {
            outState.putParcelable(KEY_CAMERA_POSITION, mMap.getCameraPosition());
            outState.putParcelable(KEY_LOCATION, mLastKnownLocation);
            super.onSaveInstanceState(outState);
        }
    }

    /**
     * Builds the map when the Google Play services client is successfully connected.
     */
    @Override
    public void onConnected(Bundle connectionHint) {
        mapFragment = (SupportMapFragment) getSupportFragmentManager().findFragmentById(R.id.map);
        mapFragment.getMapAsync(this);
//        if (shooting == null) {
//            FragmentTransaction ft = getSupportFragmentManager().beginTransaction();
//            ft.hide(mapFragment);
//            ft.commit();
//        }
    }

    /**
     * Handles failure to connect to the Google Play services client.
     */
    @Override
    public void onConnectionFailed(@NonNull ConnectionResult result) {
        // Refer to the reference doc for ConnectionResult to see what error codes might
        // be returned in onConnectionFailed.
        Log.d(TAG, "Play services connection failed: ConnectionResult.getErrorCode() = "
                + result.getErrorCode());
    }

    /**
     * Handles suspension of the connection to the Google Play services client.
     */
    @Override
    public void onConnectionSuspended(int cause) {
        Log.d(TAG, "Play services connection suspended");
    }

    @Override
    public void onMapReady(GoogleMap googleMap) {
        mMap = googleMap;
        updateLocationUI();

        // Get the current location of the device and set the position of the map.
        getDeviceLocation();
    }

    @Override
    public void onBackPressed() {
        if (materialSheetFab.isSheetVisible()) {
            materialSheetFab.hideSheet();
        } else {
            if (getSupportFragmentManager().getBackStackEntryCount() == 0) {
                super.onBackPressed();
                //additional code
            } else {
                EvidenceFragment myFragment = (EvidenceFragment) getSupportFragmentManager().findFragmentByTag("evidence");
                if (myFragment != null && myFragment.isVisible() &&
                        myFragment.getView().findViewById(R.id.evidenceFragmentInsertLayout).getVisibility() == View.VISIBLE) {
                    myFragment.getView().findViewById(R.id.evidenceFragmentInsertLayout).setVisibility(View.GONE);
                    findViewById(R.id.secondHeader).setVisibility(View.VISIBLE);
                    myFragment.getListView().setVisibility(View.VISIBLE);
                    myFragment.throwNewEvidence();
                } else {
                    super.onBackPressed();
                }
            }
        }
    }


    @Override
    public void onClick(View view) {
        materialSheetFab.hideSheet();
    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        MenuInflater inflater = getMenuInflater();
        inflater.inflate(R.menu.menu_main, menu);
        return super.onCreateOptionsMenu(menu);
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        switch (item.getItemId()) {
            case android.R.id.home:
                toggleDrawer();
                return true;
            default:
                return super.onOptionsItemSelected(item);
        }
    }

    private void doSliderAction() {
        if (evidenceFragment.isVisible()) {
            evidenceFragment.setAdapter();
        } else if (usefulInfoFragment.isVisible()) {
            usefulInfoFragment.changeView();
        }
    }

    private void updateLocationUI() {
        if (mMap == null) {
            return;
        }


        if (ContextCompat.checkSelfPermission(this.getApplicationContext(),
                android.Manifest.permission.ACCESS_FINE_LOCATION)
                == PackageManager.PERMISSION_GRANTED) {
            mLocationPermissionGranted = true;
        } else {
            ActivityCompat.requestPermissions(this,
                    new String[]{android.Manifest.permission.ACCESS_FINE_LOCATION},
                    PERMISSIONS_REQUEST_ACCESS_FINE_LOCATION);
        }

        if (mLocationPermissionGranted) {
            mMap.setMyLocationEnabled(true);
            mMap.getUiSettings().setMyLocationButtonEnabled(true);
        } else {
            mMap.setMyLocationEnabled(false);
            mMap.getUiSettings().setMyLocationButtonEnabled(false);
            mLastKnownLocation = null;
        }
    }

    /**
     * Gets the current location of the device, and positions the map's camera.
     */
    private void getDeviceLocation() {
        /*
         * Request location permission, so that we can get the location of the
         * device. The result of the permission request is handled by a callback,
         * onRequestPermissionsResult.
         */
        if (ContextCompat.checkSelfPermission(this.getApplicationContext(),
                android.Manifest.permission.ACCESS_FINE_LOCATION)
                == PackageManager.PERMISSION_GRANTED) {
            mLocationPermissionGranted = true;
        } else {
            ActivityCompat.requestPermissions(this,
                    new String[]{android.Manifest.permission.ACCESS_FINE_LOCATION},
                    PERMISSIONS_REQUEST_ACCESS_FINE_LOCATION);
        }
        /*
         * Get the best and most recent location of the device, which may be null in rare
         * cases when a location is not available.
         */
        if (mLocationPermissionGranted) {
            mLastKnownLocation = LocationServices.FusedLocationApi
                    .getLastLocation(mGoogleApiClient);
        }

        // Set the map's camera position to the current location of the device.
        if (mCameraPosition != null) {
            mMap.moveCamera(CameraUpdateFactory.newCameraPosition(mCameraPosition));
        } else if (mLastKnownLocation != null) {
            mMap.moveCamera(CameraUpdateFactory.newLatLngZoom(
                    new LatLng(mShootingLocationLat,
                            mShootingLocationLng), 10));
        } else {
            Log.d(TAG, "Current location is null. Using defaults.");
            mMap.moveCamera(CameraUpdateFactory.newLatLngZoom(mDefaultLocation, 10));
            mMap.getUiSettings().setMyLocationButtonEnabled(false);
        }
    }

    public void checkPermissionForStorage() {

        if (ContextCompat.checkSelfPermission(this,
                WRITE_EXTERNAL_STORAGE)
                != PERMISSION_GRANTED) {

            // Should we show an explanation?
            if (ActivityCompat.shouldShowRequestPermissionRationale(this,
                    WRITE_EXTERNAL_STORAGE)) {
                System.out.println("shoREquestPErmission");

            } else {

                // No explanation needed, we can request the permission.

                ActivityCompat.requestPermissions(this,
                        new String[]{WRITE_EXTERNAL_STORAGE},
                        MY_PERMISSIONS_REQUEST_WRITE_STORAGE);

            }
        }
    }

    @Override
    public void onRequestPermissionsResult(int requestCode,
                                           String permissions[], int[] grantResults) {
        switch (requestCode) {
            case MY_PERMISSIONS_REQUEST_WRITE_STORAGE: {
                // If request is cancelled, the result arrays are empty.
                if (grantResults.length > 0
                        && grantResults[0] == PackageManager.PERMISSION_GRANTED) {

                    if (evidenceFragment.isVisible()) {
                        ((EvidenceFragment) getSupportFragmentManager().findFragmentById(R.id.fragment_container)).addNewEvidence();
                    } else {
                        PlansFragment fragment = (PlansFragment) getSupportFragmentManager().findFragmentById(R.id.fragment_container);
                        fragment.getPdfFile();
                    }
                } else {

                    // permission denied, boo! Disable the
                    // functionality that depends on this permission.
                }
                return;
            }
            case PERMISSIONS_REQUEST_ACCESS_FINE_LOCATION: {
                // If request is cancelled, the result arrays are empty.
                if (grantResults.length > 0
                        && grantResults[0] == PackageManager.PERMISSION_GRANTED) {
                    mLocationPermissionGranted = true;
                    updateLocationUI();
                    getDeviceLocation();
                }
                return;
            }

            case CAMERA_PERMISSION_REQUEST: {
                // If request is cancelled, the result arrays are empty.
                if (grantResults.length > 0
                        && grantResults[0] == PackageManager.PERMISSION_GRANTED) {
                    ((EvidenceFragment) getSupportFragmentManager().findFragmentById(R.id.fragment_container)).capturePhoto();
                }
            }
        }
    }

    public String getActiveSwitcherTitle() {
        if (sliderTitles.length == evidenceReadableTitles.length) {
            return evidenceTitles[currentIndex];
        } else {
            return usefulInfoTitles[currentIndex];
        }
    }

    private void setupFab() {
        Fab fab = (Fab) findViewById(R.id.fab);
        View sheetView = findViewById(R.id.fab_sheet);
        View overlay = findViewById(R.id.overlay);
        int sheetColor = getResources().getColor(R.color.background_card);
        int fabColor = getResources().getColor(R.color.theme_accent);
        // Create material sheet FAB
        materialSheetFab = new MaterialSheetFab<>(fab, sheetView, overlay, sheetColor, fabColor);

        // Set material sheet event listener
        materialSheetFab.setEventListener(new MaterialSheetFabEventListener() {
            @Override
            public void onShowSheet() {
                // Save current status bar color
                statusBarColor = getStatusBarColor();
                // Set darker status bar color to match the dim overlay
                setStatusBarColor(getResources().getColor(R.color.theme_primary_dark2));
            }

            @Override
            public void onHideSheet() {
                // Restore status bar color
                // setStatusBarColor(statusBarColor);
            }
        });

        // Set material sheet item click listeners
        findViewById(R.id.fab_sheet_item_logout).setOnClickListener(new View.OnClickListener() {
                        @Override
            public void onClick(View v) {
                auth.signOut();
            }
        });
        findViewById(R.id.fab_sheet_item_plans).setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                materialSheetFab.hideSheet();
                findViewById(R.id.secondHeader).setVisibility(View.GONE);
                findViewById(R.id.delimiterBelow).setVisibility(View.GONE);

                layoutParams.addRule(RelativeLayout.BELOW, R.id.delimiter);

                FragmentTransaction ft = getSupportFragmentManager().beginTransaction();
                ft.setCustomAnimations(android.R.anim.fade_in,
                        android.R.anim.fade_out);
                if (plansFragment.isAdded()) { // if the fragment is already in container
                    ft.show(plansFragment);
                } else { // fragment needs to be added to frame container
                    ft.add(R.id.fragment_container, plansFragment, "plans");
                }

                if (mapFragment.isAdded()) { ft.hide(mapFragment); }
                if (evidenceFragment.isAdded()) { ft.hide(evidenceFragment); }
                if (usefulInfoFragment.isAdded()) { ft.hide(usefulInfoFragment); }

                ft.addToBackStack(null);
                ft.commit();
                ((TextView) findViewById(R.id.headerTitle)).setText(getString(R.string.planTitle));
            }
        });
        findViewById(R.id.fab_sheet_item_evidence).setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                materialSheetFab.hideSheet();
                sliderTitles = evidenceReadableTitles;
                setSlider();
                findViewById(R.id.secondHeader).setVisibility(View.VISIBLE);
                findViewById(R.id.delimiterBelow).setVisibility(View.VISIBLE);

                layoutParams.addRule(RelativeLayout.BELOW, R.id.delimiterBelow);

                FragmentTransaction ft = getSupportFragmentManager().beginTransaction();
                ft.setCustomAnimations(android.R.anim.fade_in,
                        android.R.anim.fade_out);
                if (evidenceFragment.isAdded()) { // if the fragment is already in container
                    ft.show(evidenceFragment);
                    evidenceFragment.setAdapter();
                } else { // fragment needs to be added to frame container
                    ft.add(R.id.fragment_container, evidenceFragment, "evidence");
                }

                if (mapFragment.isAdded()) { ft.hide(mapFragment); }
                if (plansFragment.isAdded()) { ft.hide(plansFragment); }
                if (usefulInfoFragment.isAdded()) { ft.hide(usefulInfoFragment); }

                ft.addToBackStack(null);
                ft.commit();

                ((TextView) findViewById(R.id.headerTitle)).setText(getString(R.string.evidenceMenuTitle));
            }
        });
        findViewById(R.id.fab_sheet_item_shooting).setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                materialSheetFab.hideSheet();
                findViewById(R.id.secondHeader).setVisibility(View.GONE);
                findViewById(R.id.delimiterBelow).setVisibility(View.GONE);

                layoutParams.addRule(RelativeLayout.BELOW, R.id.delimiter);

                FragmentTransaction ft = getSupportFragmentManager().beginTransaction();
                ft.setCustomAnimations(android.R.anim.fade_in,
                        android.R.anim.fade_out);
                ft.show(mapFragment);

                if (plansFragment.isAdded()) { ft.hide(plansFragment); }
                if (evidenceFragment.isAdded()) { ft.hide(evidenceFragment); }
                if (usefulInfoFragment.isAdded()) { ft.hide(usefulInfoFragment); }

                ft.addToBackStack(null);
                ft.commit();
                ((TextView) findViewById(R.id.headerTitle)).setText(getString(R.string.shootingMap));
            }

        });
        findViewById(R.id.fab_sheet_item_info).setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                materialSheetFab.hideSheet();
                sliderTitles = usefulInfoReadableTitles;
                setSlider();
                findViewById(R.id.secondHeader).setVisibility(View.VISIBLE);
                findViewById(R.id.delimiterBelow).setVisibility(View.VISIBLE);

                layoutParams.addRule(RelativeLayout.BELOW, R.id.delimiterBelow);

                FragmentTransaction ft = getSupportFragmentManager().beginTransaction();
                ft.setCustomAnimations(android.R.anim.fade_in,
                        android.R.anim.fade_out);
                if (usefulInfoFragment.isAdded()) { // if the fragment is already in container
                    ft.show(usefulInfoFragment);
                } else { // fragment needs to be added to frame container
                    ft.add(R.id.fragment_container, usefulInfoFragment, "usefulInfo");
                }

                if (mapFragment.isAdded()) { ft.hide(mapFragment); }
                if (evidenceFragment.isAdded()) { ft.hide(evidenceFragment); }
                if (plansFragment.isAdded()) { ft.hide(plansFragment); }

                ft.addToBackStack(null);
                ft.commit();

                ((TextView) findViewById(R.id.headerTitle)).setText(getString(R.string.usefulInfoMenuTitle));
            }

        });
    }

    private void setSlider() {
        mSwitcher.removeAllViews();
        currentIndex = 0;
        messageCount = sliderTitles.length;
        mSwitcher.setFactory(new ViewSwitcher.ViewFactory() {
            public View makeView() {
                // TODO Auto-generated method stub
                // create new textView and set the properties like clolr, size etc
                TextView myText = new TextView(MainActivity.this);
                myText.setGravity(Gravity.TOP | Gravity.CENTER_HORIZONTAL);
                myText.setTextSize(18);
                String text = sliderTitles[currentIndex];
                myText.setText(text);
//                myText.setTextColor(Color.BLUE);
                return myText;
            }
        });


        inL = AnimationUtils.loadAnimation(this,R.anim.slide_in_right);
        outL = AnimationUtils.loadAnimation(this,R.anim.slide_out_left);
        inR = AnimationUtils.loadAnimation(this,android.R.anim.slide_in_left);
        outR = AnimationUtils.loadAnimation(this,android.R.anim.slide_out_right);

        buttonLeft.setOnClickListener(new View.OnClickListener() {

            public void onClick(View v) {
                // TODO Auto-generated method stub
                mSwitcher.setInAnimation(inL);
                mSwitcher.setOutAnimation(outL);
                currentIndex--;
                // If index reaches maximum reset it
                if(currentIndex == -1)
                    currentIndex=messageCount-1;
                mSwitcher.setText(sliderTitles[currentIndex]);
                doSliderAction();
            }
        });

        buttonRight.setOnClickListener(new View.OnClickListener() {

            public void onClick(View v) {
                // TODO Auto-generated method stub
                // set the animation type of textSwitcher
                mSwitcher.setInAnimation(inR);
                mSwitcher.setOutAnimation(outR);
                currentIndex++;
                // If index reaches maximum reset it
                if(currentIndex == messageCount)
                    currentIndex=0;
                mSwitcher.setText(sliderTitles[currentIndex]);
                doSliderAction();
            }
        });
    }


    private int getStatusBarColor() {
        if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.LOLLIPOP) {
            return getWindow().getStatusBarColor();
        }
        return 0;
    }

    private void setStatusBarColor(int color) {
        if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.LOLLIPOP) {
            getWindow().setStatusBarColor(color);
        }
    }

    private void toggleDrawer() {
        if (drawerLayout.isDrawerVisible(GravityCompat.START)) {
            drawerLayout.closeDrawer(GravityCompat.START);
        } else {
            drawerLayout.openDrawer(GravityCompat.START);
        }
    }

    @Override
    protected void onStart() {
        super.onStart();
        auth.addAuthStateListener(mAuthListener);
        Log.d(TAG, "onStart!");
    }

    @Override
    protected void onStop() {
        super.onStop();
        if (mAuthListener != null) {
            auth.removeAuthStateListener(mAuthListener);
        }
        Log.d(TAG, "onStop!");
    }

    @Override
    public void onFragmentInteraction(Uri uri) {
        System.out.println(uri);
    }

    public String getYear() {
        return year;
    }

    public String getShooting() {
        return shooting;
    }

    public String getUid() {
        return uid;
    }

    public FirebaseDatabase getFirebaseDatabase() {
        return firebaseDatabase;
    }
}
