package com.koucky.petr.mysldenik.adapter;

import android.app.Activity;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.support.annotation.NonNull;
import android.util.Base64;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ImageView;
import android.widget.TextView;

import com.koucky.petr.mysldenik.R;
import com.koucky.petr.mysldenik.entity.evidence.EvidenceAdapterModel;

import java.util.List;

/**
 * Created by koucky on 5/1/17.
 */

public class TwoTextImageAdapter extends AbstractArrayAdapter {

    public TwoTextImageAdapter(Activity context, List<EvidenceAdapterModel> list) {
        super(context, R.layout.row_layout, list);
    }

    @NonNull
    @Override
    public View getView(int position, View convertView, @NonNull ViewGroup parent) {
        EvidenceAdapterModel item = getItem(position);


        // Check if an existing view is being reused, otherwise inflate the view
        ViewHolder viewHolder; // view lookup cache stored in tag
        if (convertView == null) {
            // If there's no view to re-use, inflate a brand new view for row
            viewHolder = new ViewHolder();
            LayoutInflater inflater = LayoutInflater.from(getContext());
            convertView = inflater.inflate(R.layout.row_layout, parent, false);
            viewHolder.firstLine = (TextView) convertView.findViewById(R.id.firstLine);
            viewHolder.secondLine = (TextView) convertView.findViewById(R.id.secondLine);
            viewHolder.thirdLine = (TextView) convertView.findViewById(R.id.thirdLine);
            viewHolder.imageView = (ImageView) convertView.findViewById(R.id.image);
            // Cache the viewHolder object inside the fresh view
            convertView.setTag(viewHolder);
        } else {
            // View is being recycled, retrieve the viewHolder object from tag
            viewHolder = (ViewHolder) convertView.getTag();
        }
        // Populate the data from the data object via the viewHolder object
        // into the template view.
        viewHolder.firstLine.setText(item.firstLine);
        viewHolder.secondLine.setText(item.secondLine);
        viewHolder.thirdLine.setText(item.thirdLine);
        if (item.imageView.isEmpty()) {
            viewHolder.imageView.setImageResource(R.mipmap.antlers_launcher);
        } else {
            viewHolder.imageView.setImageBitmap(decodeBase64(item.imageView));
        }
        // Return the completed view to render on screen
        return convertView;
    }

    private Bitmap decodeBase64(String input) {
        byte[] decodedBytes = Base64.decode(input, 0);
        return BitmapFactory.decodeByteArray(decodedBytes, 0, decodedBytes.length);
    }
}
