package com.koucky.petr.mysldenik.fragments;

import android.content.ContentValues;
import android.content.Context;
import android.content.Intent;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Matrix;
import android.net.Uri;
import android.os.Bundle;
import android.provider.MediaStore;
import android.support.design.widget.FloatingActionButton;
import android.support.v4.app.ActivityCompat;
import android.support.v4.app.Fragment;
import android.support.v4.app.FragmentManager;
import android.support.v4.app.ListFragment;
import android.support.v4.content.ContextCompat;
import android.text.InputType;
import android.util.Base64;
import android.view.LayoutInflater;
import android.view.MotionEvent;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.EditText;
import android.widget.ImageView;
import android.widget.ListView;
import android.widget.RelativeLayout;
import android.widget.Spinner;
import android.widget.TextView;
import android.widget.Toast;

import com.google.firebase.database.DataSnapshot;
import com.google.firebase.database.DatabaseError;
import com.google.firebase.database.FirebaseDatabase;
import com.google.firebase.database.ValueEventListener;
import com.koucky.petr.mysldenik.MainActivity;
import com.koucky.petr.mysldenik.R;
import com.koucky.petr.mysldenik.adapter.AbstractArrayAdapter;
import com.koucky.petr.mysldenik.adapter.TwoTextImageAdapter;
import com.koucky.petr.mysldenik.entity.evidence.EvidenceAdapterModel;
import com.koucky.petr.mysldenik.entity.evidence.EvidenceDamages;
import com.koucky.petr.mysldenik.entity.evidence.EvidenceDiseases;
import com.koucky.petr.mysldenik.entity.evidence.EvidenceModel;
import com.koucky.petr.mysldenik.entity.evidence.EvidenceSharedHunts;
import com.koucky.petr.mysldenik.entity.evidence.EvidenceShooting;
import com.koucky.petr.mysldenik.entity.evidence.EvidenceSingleHunts;
import com.wdullaer.materialdatetimepicker.date.DatePickerDialog;

import java.io.ByteArrayOutputStream;
import java.io.FileNotFoundException;
import java.io.InputStream;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.HashMap;
import java.util.List;

import static android.Manifest.permission.CAMERA;
import static android.Manifest.permission.WRITE_EXTERNAL_STORAGE;
import static android.app.Activity.RESULT_OK;
import static android.content.pm.PackageManager.PERMISSION_GRANTED;


/**
 * A simple {@link Fragment} subclass.
 * Activities that contain this fragment must implement the
 * {@link EvidenceFragment.OnFragmentInteractionListener} interface
 * to handle interaction events.
 * Use the {@link EvidenceFragment#newInstance} factory method to
 * create an instance of this fragment.
 */
public class EvidenceFragment extends ListFragment implements DatePickerDialog.OnDateSetListener {
    // TODO: Rename parameter arguments, choose names that match
    // the fragment initialization parameters, e.g. ARG_ITEM_NUMBER
    private static final String DEFAULT_EVEIDENCE = "param1";
    private static final String ARG_PARAM2 = "param2";
    private static final int RESULT_LOAD_IMG = 185;
    private static final int CAMERA_REQUEST = 458;
    private static final int CAMERA_PERMISSION_REQUEST = 966;
    private static final int MAX_RESOLUTION = 1280;

    // TODO: Rename and change types of parameters
    private String defaultEvidence;
    private String mParam2;
    private AbstractArrayAdapter adapter;
    private FirebaseDatabase firebaseDatabase;
    private EvidenceModel evidenceModel;
    private Uri selectedImage;
    private Uri imageUri;
    private ContentValues values;
    private RelativeLayout evidenceInsertLayout;
    private RelativeLayout evidenceLayout;
    private EvidenceModel newEvidence;
    private String imageBase64 = "";
    private boolean addingImage = false;
    private String uidShootingYear = "";
    private String actualType = "";
    private HashMap<String, List<EvidenceModel>> evidences = new HashMap<>();

    private OnFragmentInteractionListener mListener;

    public EvidenceFragment() {
        // Required empty public constructor
    }

    /**
     * Use this factory method to create a new instance of
     * this fragment using the provided parameters.
     *
     * @param param1 Parameter 1.
     * @param param2 Parameter 2.
     * @return A new instance of fragment EvidenceFragment.
     */
    // TODO: Rename and change types and number of parameters
    public static EvidenceFragment newInstance(String param1, String param2) {
        EvidenceFragment fragment = new EvidenceFragment();
        Bundle args = new Bundle();
        args.putString(DEFAULT_EVEIDENCE, param1);
        args.putString(ARG_PARAM2, param2);
        fragment.setArguments(args);
        return fragment;
    }

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        if (getArguments() != null) {
            defaultEvidence = getArguments().getString(DEFAULT_EVEIDENCE);
            mParam2 = getArguments().getString(ARG_PARAM2);
        }

        evidences.put("damages", new ArrayList<EvidenceModel>());
        evidences.put("sharedHunts", new ArrayList<EvidenceModel>());
        evidences.put("singleHunts", new ArrayList<EvidenceModel>());
        evidences.put("diseases", new ArrayList<EvidenceModel>());
        evidences.put("shooting", new ArrayList<EvidenceModel>());
    }

    @Override
    public void onActivityCreated(Bundle savedInstanceState) {
        super.onActivityCreated(savedInstanceState);
        firebaseDatabase = ((MainActivity)getActivity()).getFirebaseDatabase();
        setAdapter();
    }

    public void clearEvidences() {
        for (List<EvidenceModel> evidence : evidences.values()) {
            evidence.clear();
        }
    }

    public void setAdapter() {
        ((MainActivity)getActivity()).getProgressBar().setVisibility(View.VISIBLE);
        actualType = ((MainActivity)getActivity()).getActiveSwitcherTitle();
        if (!evidences.get(actualType).isEmpty()) {
            ((MainActivity)getActivity()).getProgressBar().setVisibility(View.INVISIBLE);
            adapter = new TwoTextImageAdapter(getActivity(), getAdapterModels(evidences.get(actualType), actualType));
            setListAdapter(adapter);
            return;
        }
        uidShootingYear = ((MainActivity)getActivity()).getUid() + "/"
                + ((MainActivity)getActivity()).getShooting() + "/"
                + ((MainActivity)getActivity()).getYear() + "/";
        firebaseDatabase.getReference("evidences/" + uidShootingYear + "/" + actualType).addValueEventListener(
                new ValueEventListener() {

            @Override
            public void onDataChange(DataSnapshot snapshot) {
                if (adapter != null) adapter.clear();
                evidences.get(actualType).clear();
                for (DataSnapshot child : snapshot.getChildren()) {
                    evidences.get(actualType).add(child.getValue(getRightModel(actualType).getClass()));
                }

                ((MainActivity)getActivity()).getProgressBar().setVisibility(View.INVISIBLE);
                adapter = new TwoTextImageAdapter(getActivity(), getAdapterModels(evidences.get(actualType), actualType));
                setListAdapter(adapter);
            }

            @Override
            public void onCancelled(DatabaseError databaseError) {
                ((MainActivity)getActivity()).getProgressBar().setVisibility(View.INVISIBLE);
                adapter = new TwoTextImageAdapter(getActivity(), new ArrayList<EvidenceAdapterModel>());
                setListAdapter(adapter);
            }
        });

    }

    private EvidenceModel getRightModel(String type) {
        switch (type) {
            case "damages":
                return new EvidenceDamages();
            case "sharedHunts":
                return new EvidenceSharedHunts();
            case "singleHunts":
                return new EvidenceSingleHunts();
            case "diseases":
                return new EvidenceDiseases();
            case "shooting":
                return new EvidenceShooting();
            default: return null;
        }
    }

    private List<EvidenceAdapterModel> getAdapterModels(List<EvidenceModel> evidencesToShow, String type) {
        List<EvidenceAdapterModel> models = new ArrayList<>();
        switch (type) {
            case "damages":
                EvidenceDamages evD;
                for (EvidenceModel ev : evidencesToShow) {
                    evD = (EvidenceDamages) ev;
                    models.add(new EvidenceAdapterModel(evD.date, evD.damage, evD.game, evD.image));
                }
                break;
            case "sharedHunts":
                EvidenceSharedHunts evSH;
                for (EvidenceModel ev : evidencesToShow) {
                    evSH = (EvidenceSharedHunts) ev;
                    models.add(new EvidenceAdapterModel(evSH.date, evSH.hunter, evSH.game, evSH.image));
                }
                break;
            case "singleHunts":
                EvidenceSingleHunts evSiH;
                for (EvidenceModel ev : evidencesToShow) {
                    evSiH = (EvidenceSingleHunts) ev;
                    models.add(new EvidenceAdapterModel(evSiH.date, evSiH.hunter, evSiH.game, evSiH.image));
                }
                break;
            case "diseases":
                EvidenceDiseases evDi;
                for (EvidenceModel ev : evidencesToShow) {
                    evDi = (EvidenceDiseases) ev;
                    models.add(new EvidenceAdapterModel(evDi.date, evDi.cause, evDi.game, evDi.image));
                }
                break;
            case "shooting":
                EvidenceShooting evS;
                for (EvidenceModel ev : evidencesToShow) {
                    evS = (EvidenceShooting) ev;
                    models.add(new EvidenceAdapterModel(evS.date, evS.repast, evS.warehouse, evS.image));
                }
                break;
            default:
                models = null;
        }

        return models;
    }

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {
        // Inflate the layout for this fragment
        View view = inflater.inflate(R.layout.fragment_evidence, container, false);
        view.findViewById(R.id.addEvidence).setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                addNewEvidence();
            }
        });

        view.findViewById(R.id.throwEvidence).setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                throwNewEvidence();
            }
        });

        return view;
    }

    @Override
    public void onDateSet(DatePickerDialog view, int year, int monthOfYear, int dayOfMonth) {
        String date = dayOfMonth+"/"+(monthOfYear+1)+"/"+year;
        ((TextView)getView().findViewById(R.id.date)).setText(date);
    }

    private int getRightEvidenceToAdd() {
        switch (actualType) {
            case "damages": return R.layout.evidence_damages_add;
            case "sharedHunts": return R.layout.evidence_shared_hunts_add;
            case "singleHunts": return R.layout.evidence_single_hunts_add;
            case "diseases": return R.layout.evidence_diseases_add;
            case "shooting": return R.layout.evidence_shooting_add;

            default: return 0;
        }
    }

    private void setDate() {
        Calendar now = Calendar.getInstance();
        DatePickerDialog dpd = DatePickerDialog.newInstance(
                this,
                now.get(Calendar.YEAR),
                now.get(Calendar.MONTH),
                now.get(Calendar.DAY_OF_MONTH)
        );
        dpd.setVersion(DatePickerDialog.Version.VERSION_1);
        dpd.show(getActivity().getFragmentManager(), "Datepickerdialog");
    }

    public void addNewEvidence() {
        if (addingImage) {
            createEvidence();
        } else {
            addingImage = true;
            if (getView() != null) {
                getView().findViewById(R.id.throwEvidence).setVisibility(View.VISIBLE);
                LayoutInflater inflater = LayoutInflater.from(getContext());
                evidenceLayout = (RelativeLayout) inflater.inflate(getRightEvidenceToAdd(), null, false);
                evidenceInsertLayout = (RelativeLayout) getView().findViewById(R.id.evidenceFragmentInsertLayout);
                getListView().setVisibility(View.GONE);
                getActivity().findViewById(R.id.secondHeader).setVisibility(View.GONE);

                int permissionCheck = ContextCompat.checkSelfPermission(getActivity(),
                        WRITE_EXTERNAL_STORAGE);

                if (permissionCheck == PERMISSION_GRANTED) {
                    evidenceLayout.findViewById(R.id.getPhoto).setOnClickListener(new View.OnClickListener() {
                        @Override
                        public void onClick(View v) {
                            getPhotoFromGallery();
                        }
                    });

                    evidenceLayout.findViewById(R.id.capturePhoto).setOnClickListener(new View.OnClickListener() {
                        @Override
                        public void onClick(View v) {
                            if (ContextCompat.checkSelfPermission(getActivity(), CAMERA) != PERMISSION_GRANTED) {
                                ActivityCompat.requestPermissions(getActivity(), new String[] { CAMERA }, CAMERA_PERMISSION_REQUEST);
                            } else {
                                capturePhoto();
                            }
                        }
                    });

                    evidenceLayout.findViewById(R.id.date).setOnClickListener(new View.OnClickListener() {
                        @Override
                        public void onClick(View v) {
                            setDate();
                        }
                    });

                    evidenceInsertLayout.removeAllViews();
                    evidenceInsertLayout.addView(evidenceLayout);
                    ((FloatingActionButton) getView().findViewById(R.id.addEvidence)).setImageResource(R.drawable.ic_check_ok);
                    evidenceInsertLayout.setVisibility(View.VISIBLE);
                    if (!actualType.equals("shooting")) {
                        Spinner spinner = (Spinner) evidenceLayout.findViewById(R.id.sex);
                        // Create an ArrayAdapter using the string array and a default spinner layout
                        ArrayAdapter<CharSequence> adapter = ArrayAdapter.createFromResource(getContext(),
                                R.array.gameSex, R.layout.spinner_item);
                        // Specify the layout to use when the list of choices appears
                        adapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
                        // Apply the adapter to the spinner
                        spinner.setAdapter(adapter);
                    }
                } else {
                    addingImage = false;
                    ((MainActivity) getActivity()).checkPermissionForStorage();
                }

            }
        }
    }

    private String getReadableSex(String sex) {
        switch (sex) {
            case "male-1":
                return "I. věk. tř.";

            case "male-2":
                return "II. věk. tř.";

            case "male-3":
                return "III. věk. tř.";

            case "female":
                return "Samice";

            case "spring":
                return "Mládě";

            default:
                return "";
        }
    }

    private String getDbSex(String sex) {
        switch (sex) {
            case "I. věk. tř.":
                return "male-1";

            case "II. věk. tř.":
                return "male-2";

            case "III. věk. tř.":
                return "male-3";

            case "Samice":
                return "female";

            case "Mládě":
                return "spring";

            default:
                return "";
        }
    }

    private void createEvidence() {
        switch (actualType) {
            case "damages":
                EvidenceDamages newDamages = new EvidenceDamages();
                newDamages.date = ((TextView) evidenceLayout.findViewById(R.id.date)).getText().toString();
                newDamages.game = ((TextView) evidenceLayout.findViewById(R.id.game)).getText().toString();
                newDamages.sex = getDbSex(((Spinner) evidenceLayout.findViewById(R.id.sex)).getSelectedItem().toString());
                newDamages.age = ((TextView) evidenceLayout.findViewById(R.id.age)).getText().toString();
                newDamages.place = ((TextView) evidenceLayout.findViewById(R.id.place)).getText().toString();
                newDamages.damage = ((TextView) evidenceLayout.findViewById(R.id.damage)).getText().toString();
                newDamages.note = ((TextView) evidenceLayout.findViewById(R.id.note)).getText().toString();
                newDamages.image = imageBase64;

                firebaseDatabase.getReference("evidences/" + uidShootingYear + "damages").push().setValue(newDamages);
                break;

            case "sharedHunts":
                EvidenceSharedHunts newSharedHunts = new EvidenceSharedHunts();
                newSharedHunts.date = ((TextView) evidenceLayout.findViewById(R.id.date)).getText().toString();
                newSharedHunts.game = ((TextView) evidenceLayout.findViewById(R.id.game)).getText().toString();
                newSharedHunts.sex = getDbSex(((Spinner) evidenceLayout.findViewById(R.id.sex)).getSelectedItem().toString());
                newSharedHunts.age = ((TextView) evidenceLayout.findViewById(R.id.age)).getText().toString();
                newSharedHunts.place = ((TextView) evidenceLayout.findViewById(R.id.place)).getText().toString();
                newSharedHunts.hunter = ((TextView) evidenceLayout.findViewById(R.id.hunter)).getText().toString();
                newSharedHunts.trophy = ((TextView) evidenceLayout.findViewById(R.id.trophy)).getText().toString();
                newSharedHunts.weight = ((TextView) evidenceLayout.findViewById(R.id.weight)).getText().toString();
                newSharedHunts.note = ((TextView) evidenceLayout.findViewById(R.id.note)).getText().toString();
                newSharedHunts.image = imageBase64;

                firebaseDatabase.getReference("evidences/" + uidShootingYear + "sharedHunts").push().setValue(newSharedHunts);
                break;

            case "singleHunts":
                EvidenceSingleHunts newSingleHunts = new EvidenceSingleHunts();
                newSingleHunts.date = ((TextView) evidenceLayout.findViewById(R.id.date)).getText().toString();
                newSingleHunts.game = ((TextView) evidenceLayout.findViewById(R.id.game)).getText().toString();
                newSingleHunts.sex = getDbSex(((Spinner) evidenceLayout.findViewById(R.id.sex)).getSelectedItem().toString());
                newSingleHunts.age = ((TextView) evidenceLayout.findViewById(R.id.age)).getText().toString();
                newSingleHunts.place = ((TextView) evidenceLayout.findViewById(R.id.place)).getText().toString();
                newSingleHunts.hunter = ((TextView) evidenceLayout.findViewById(R.id.hunter)).getText().toString();
                newSingleHunts.trophy = ((TextView) evidenceLayout.findViewById(R.id.trophy)).getText().toString();
                newSingleHunts.weight = ((TextView) evidenceLayout.findViewById(R.id.weight)).getText().toString();
                newSingleHunts.note = ((TextView) evidenceLayout.findViewById(R.id.note)).getText().toString();
                newSingleHunts.image = imageBase64;

                firebaseDatabase.getReference("evidences/" + uidShootingYear + "singleHunts").push().setValue(newSingleHunts);
                break;

            case "diseases":
                EvidenceDiseases newDiseases = new EvidenceDiseases();
                newDiseases.date = ((TextView) evidenceLayout.findViewById(R.id.date)).getText().toString();
                newDiseases.game = ((TextView) evidenceLayout.findViewById(R.id.game)).getText().toString();
                newDiseases.sex = getDbSex(((Spinner) evidenceLayout.findViewById(R.id.sex)).getSelectedItem().toString());
                newDiseases.age = ((TextView) evidenceLayout.findViewById(R.id.age)).getText().toString();
                newDiseases.place = ((TextView) evidenceLayout.findViewById(R.id.place)).getText().toString();
                newDiseases.cause = ((TextView) evidenceLayout.findViewById(R.id.cause)).getText().toString();
                newDiseases.note = ((TextView) evidenceLayout.findViewById(R.id.note)).getText().toString();
                newDiseases.image = imageBase64;

                firebaseDatabase.getReference("evidences/" + uidShootingYear + "diseases").push().setValue(newDiseases);
                break;

            case "shooting":
                EvidenceShooting newShooting = new EvidenceShooting();
                newShooting.date = ((TextView) evidenceLayout.findViewById(R.id.date)).getText().toString();
                newShooting.repast = ((TextView) evidenceLayout.findViewById(R.id.repast)).getText().toString();
                newShooting.warehouse = ((TextView) evidenceLayout.findViewById(R.id.warehouse)).getText().toString();
                newShooting.volume = ((TextView) evidenceLayout.findViewById(R.id.volume)).getText().toString();
                newShooting.note = ((TextView) evidenceLayout.findViewById(R.id.note)).getText().toString();
                newShooting.image = imageBase64;

                firebaseDatabase.getReference("evidences/" + uidShootingYear + "shooting").push().setValue(newShooting);
        }

        throwNewEvidence();
    }

    private Bitmap getResizedBitmap(Bitmap bm) {
        int width = bm.getWidth();
        int height = bm.getHeight();
        int newWidth;
        int newHeight;
        if (width > MAX_RESOLUTION && width > height) {
            newWidth = 1280;
            newHeight = getResizeRatio(width, height);
        } else if (height > MAX_RESOLUTION && height > width) {
            newHeight = 1280;
            newWidth = getResizeRatio(height, width);
        } else {
            return bm;
        }

        float scaleWidth = ((float) newWidth) / width;
        float scaleHeight = ((float) newHeight) / height;
        // CREATE A MATRIX FOR THE MANIPULATION
        Matrix matrix = new Matrix();
        // RESIZE THE BIT MAP
        matrix.postScale(scaleWidth, scaleHeight);

        // "RECREATE" THE NEW BITMAP
        Bitmap resizedBitmap = Bitmap.createBitmap(
                bm, 0, 0, width, height, matrix, false);
        bm.recycle();
        return resizedBitmap;
    }

    private int getResizeRatio(int toResize, int getRatioOf) {
        int difference = toResize - MAX_RESOLUTION;
        double ratio = difference/(toResize/100);
        return getRatioOf - ((int) Math.round(getRatioOf * (ratio/100)));
    }

    private void getPhotoFromGallery() {
        Intent photoPickerIntent = new Intent(Intent.ACTION_PICK);
        photoPickerIntent.setType("image/*");
        startActivityForResult(photoPickerIntent, RESULT_LOAD_IMG);
    }

    public void capturePhoto() {
        values = new ContentValues();
        values.put(MediaStore.Images.Media.TITLE, "New Picture");
        values.put(MediaStore.Images.Media.DESCRIPTION, "From your Camera");
        imageUri = getContext().getContentResolver().insert(
                MediaStore.Images.Media.EXTERNAL_CONTENT_URI, values);
        Intent intent = new Intent(MediaStore.ACTION_IMAGE_CAPTURE);
        intent.putExtra(MediaStore.EXTRA_OUTPUT, imageUri);
        startActivityForResult(intent, CAMERA_REQUEST);
    }

    private String encodeToBase64(Bitmap image, Bitmap.CompressFormat compressFormat, int quality) {
        ByteArrayOutputStream byteArrayOS = new ByteArrayOutputStream();
        image.compress(compressFormat, quality, byteArrayOS);
        return Base64.encodeToString(byteArrayOS.toByteArray(), Base64.DEFAULT);
    }

    private Bitmap decodeBase64(String input) {
        byte[] decodedBytes = Base64.decode(input, 0);
        return BitmapFactory.decodeByteArray(decodedBytes, 0, decodedBytes.length);
    }

    @Override
    public void onActivityResult(int reqCode, int resultCode, Intent data) {
        super.onActivityResult(reqCode, resultCode, data);
        RelativeLayout.LayoutParams params = (RelativeLayout.LayoutParams) getView().findViewById(R.id.buttons_layout).getLayoutParams();
        params.addRule(RelativeLayout.ALIGN_PARENT_BOTTOM);
        params.addRule(RelativeLayout.ALIGN_PARENT_END);
        params.removeRule(RelativeLayout.CENTER_IN_PARENT);
        Bitmap resizedImage = null;
        if (reqCode == RESULT_LOAD_IMG && resultCode == RESULT_OK) {
            try {
                final Uri imageUri = data.getData();
                final InputStream imageStream = getContext().getContentResolver().openInputStream(imageUri);
                final Bitmap selectedImage = BitmapFactory.decodeStream(imageStream);
                resizedImage = getResizedBitmap(selectedImage);
                ((ImageView) getView().findViewById(R.id.image_view)).setImageBitmap(resizedImage);
                getView().findViewById(R.id.buttons_layout).setLayoutParams(params); //causes layout update
                getView().findViewById(R.id.image_view).setVisibility(View.VISIBLE);
            } catch (FileNotFoundException e) {
                e.printStackTrace();
                Toast.makeText(getContext(), "Something went wrong", Toast.LENGTH_LONG).show();
            }
        } else if (reqCode == CAMERA_REQUEST && resultCode == RESULT_OK) {
            try {
                Bitmap thumbnail = MediaStore.Images.Media.getBitmap(
                        getContext().getContentResolver(), imageUri);
                resizedImage = getResizedBitmap(thumbnail);
                ((ImageView) getView().findViewById(R.id.image_view)).setImageBitmap(resizedImage);
                getView().findViewById(R.id.buttons_layout).setLayoutParams(params); //causes layout update
                getView().findViewById(R.id.image_view).setVisibility(View.VISIBLE);
            } catch (Exception e) {
                e.printStackTrace();
            }
//
//            Bitmap photo = (Bitmap) data.getExtras().get("data");
//            final Bitmap resizedImage = getResizedBitmap(photo);
//            ((ImageView) getView().findViewById(R.id.image_view)).setImageBitmap(resizedImage);
//            getView().findViewById(R.id.buttons_layout).setLayoutParams(params); //causes layout update
//            getView().findViewById(R.id.image_view).setVisibility(View.VISIBLE);
        } else {
            Toast.makeText(getContext(), "You haven't picked Image",Toast.LENGTH_LONG).show();
        }
        if (resizedImage != null) {
            imageBase64 = encodeToBase64(resizedImage, Bitmap.CompressFormat.JPEG, 100);
        }
    }

    public void throwNewEvidence() {
        addingImage = false;
        imageBase64 = "";
        if (getView() != null) {
            getView().findViewById(R.id.throwEvidence).setVisibility(View.GONE);
            RelativeLayout linear = (RelativeLayout) getView().findViewById(R.id.evidenceFragmentInsertLayout);
            getListView().setVisibility(View.VISIBLE);
            getActivity().findViewById(R.id.secondHeader).setVisibility(View.VISIBLE);
            if (getView().findViewById(R.id.buttons_layout) != null) {
                RelativeLayout.LayoutParams params = (RelativeLayout.LayoutParams) getView().findViewById(R.id.buttons_layout).getLayoutParams();
                params.removeRule(RelativeLayout.ALIGN_PARENT_BOTTOM);
                params.removeRule(RelativeLayout.ALIGN_PARENT_END);
                params.addRule(RelativeLayout.CENTER_IN_PARENT);
                getView().findViewById(R.id.buttons_layout).setLayoutParams(params); //causes layout update
            }
            ((FloatingActionButton) getView().findViewById(R.id.addEvidence)).setImageResource(android.R.drawable.ic_menu_add);
            linear.removeAllViews();
        }
    }

    @Override
    public void onListItemClick(ListView l, View v, int position, long id) {
        RelativeLayout layout = fillLayout(position);
        RelativeLayout linear = (RelativeLayout) getView().findViewById(R.id.evidenceFragmentInsertLayout);
        getListView().setVisibility(View.GONE);
        getActivity().findViewById(R.id.secondHeader).setVisibility(View.GONE);
        linear.removeAllViews();
        linear.addView(layout);
        linear.setVisibility(View.VISIBLE);
    }

    private RelativeLayout fillLayout(int position) {
        RelativeLayout layout;
        LayoutInflater inflater = LayoutInflater.from(getContext());
        switch (actualType) {
            case "damages":
                EvidenceDamages damage = (EvidenceDamages) evidences.get(actualType).get(position);
                layout = (RelativeLayout) inflater.inflate(R.layout.evidence_damages_detail, null, false);
                ((TextView)layout.findViewById(R.id.date)).setText(damage.date);
                ((TextView)layout.findViewById(R.id.game)).setText(damage.game);
                ((TextView)layout.findViewById(R.id.sex)).setText(getReadableSex(damage.sex));
                ((TextView)layout.findViewById(R.id.age)).setText(damage.age);
                ((TextView)layout.findViewById(R.id.place)).setText(damage.place);
                ((TextView)layout.findViewById(R.id.damage)).setText(damage.damage);
                ((TextView)layout.findViewById(R.id.note)).setText(damage.note);
                if (damage.image != null && !damage.image.isEmpty()) {
                    ((ImageView) layout.findViewById(R.id.image_view)).setImageBitmap(decodeBase64(damage.image));
                } else {
                    ((ImageView) layout.findViewById(R.id.image_view)).setImageResource(R.drawable.ic_no_image);
                }

                return layout;

            case "sharedHunts":
                EvidenceSharedHunts sharedHunt = (EvidenceSharedHunts) evidences.get(actualType).get(position);
                layout = (RelativeLayout) inflater.inflate(R.layout.evidence_shared_hunts_detail, null, false);
                ((TextView)layout.findViewById(R.id.date)).setText(sharedHunt.date);
                ((TextView)layout.findViewById(R.id.game)).setText(sharedHunt.game);
                ((TextView)layout.findViewById(R.id.sex)).setText(getReadableSex(sharedHunt.sex));
                ((TextView)layout.findViewById(R.id.age)).setText(sharedHunt.age);
                ((TextView)layout.findViewById(R.id.place)).setText(sharedHunt.place);
                ((TextView)layout.findViewById(R.id.trophy)).setText(sharedHunt.trophy);
                ((TextView)layout.findViewById(R.id.weight)).setText(sharedHunt.weight);
                ((TextView)layout.findViewById(R.id.hunter)).setText(sharedHunt.hunter);
                ((TextView)layout.findViewById(R.id.note)).setText(sharedHunt.note);
                if (sharedHunt.image != null && !sharedHunt.image.isEmpty()) {
                    ((ImageView) layout.findViewById(R.id.image_view)).setImageBitmap(decodeBase64(sharedHunt.image));
                } else {
                    ((ImageView) layout.findViewById(R.id.image_view)).setImageResource(R.drawable.ic_no_image);
                }

                return layout;

            case "singleHunts":
                EvidenceSingleHunts singleHunts = (EvidenceSingleHunts) evidences.get(actualType).get(position);
                layout = (RelativeLayout) inflater.inflate(R.layout.evidence_single_hunts_detail, null, false);
                ((TextView)layout.findViewById(R.id.date)).setText(singleHunts.date);
                ((TextView)layout.findViewById(R.id.game)).setText(singleHunts.game);
                ((TextView)layout.findViewById(R.id.sex)).setText(getReadableSex(singleHunts.sex));
                ((TextView)layout.findViewById(R.id.age)).setText(singleHunts.age);
                ((TextView)layout.findViewById(R.id.place)).setText(singleHunts.place);
                ((TextView)layout.findViewById(R.id.trophy)).setText(singleHunts.trophy);
                ((TextView)layout.findViewById(R.id.weight)).setText(singleHunts.weight);
                ((TextView)layout.findViewById(R.id.hunter)).setText(singleHunts.hunter);
                ((TextView)layout.findViewById(R.id.note)).setText(singleHunts.note);
                if (singleHunts.image != null && !singleHunts.image.isEmpty()) {
                    ((ImageView) layout.findViewById(R.id.image_view)).setImageBitmap(decodeBase64(singleHunts.image));
                } else {
                    ((ImageView) layout.findViewById(R.id.image_view)).setImageResource(R.drawable.ic_no_image);
                }

                return layout;

            case "diseases":
                EvidenceDiseases diseases = (EvidenceDiseases) evidences.get(actualType).get(position);
                layout = (RelativeLayout) inflater.inflate(R.layout.evidence_diseases_detail, null, false);
                ((TextView)layout.findViewById(R.id.date)).setText(diseases.date);
                ((TextView)layout.findViewById(R.id.game)).setText(diseases.game);
                ((TextView)layout.findViewById(R.id.sex)).setText(getReadableSex(diseases.sex));
                ((TextView)layout.findViewById(R.id.age)).setText(diseases.age);
                ((TextView)layout.findViewById(R.id.place)).setText(diseases.place);
                ((TextView)layout.findViewById(R.id.cause)).setText(diseases.cause);
                ((TextView)layout.findViewById(R.id.note)).setText(diseases.note);
                if (diseases.image != null && !diseases.image.isEmpty()) {
                    ((ImageView) layout.findViewById(R.id.image_view)).setImageBitmap(decodeBase64(diseases.image));
                } else {
                    ((ImageView) layout.findViewById(R.id.image_view)).setImageResource(R.drawable.ic_no_image);
                }

                return layout;

            case "shooting":
                EvidenceShooting shooting = (EvidenceShooting) evidences.get(actualType).get(position);
                layout = (RelativeLayout) inflater.inflate(R.layout.evidence_shooting_detail, null, false);
                ((TextView)layout.findViewById(R.id.date)).setText(shooting.date);
                ((TextView)layout.findViewById(R.id.repast)).setText(shooting.repast);
                ((TextView)layout.findViewById(R.id.volume)).setText(shooting.volume);
                ((TextView)layout.findViewById(R.id.warehouse)).setText(shooting.warehouse);
                ((TextView)layout.findViewById(R.id.note)).setText(shooting.note);
                if (shooting.image != null && !shooting.image.isEmpty()) {
                    ((ImageView) layout.findViewById(R.id.image_view)).setImageBitmap(decodeBase64(shooting.image));
                } else {
                    ((ImageView) layout.findViewById(R.id.image_view)).setImageResource(R.drawable.ic_no_image);
                }

                return layout;

            default: return null;
        }
    }

    // TODO: Rename method, update argument and hook method into UI event
    public void onButtonPressed(Uri uri) {
        if (mListener != null) {
            mListener.onFragmentInteraction(uri);
        }
    }

    @Override
    public void onAttach(Context context) {
        super.onAttach(context);
        if (context instanceof OnFragmentInteractionListener) {
            mListener = (OnFragmentInteractionListener) context;
        } else {
            throw new RuntimeException(context.toString()
                    + " must implement OnFragmentInteractionListener");
        }
    }

    @Override
    public void onDetach() {
        super.onDetach();
        mListener = null;
    }

    /**
     * This interface must be implemented by activities that contain this
     * fragment to allow an interaction in this fragment to be communicated
     * to the activity and potentially other fragments contained in that
     * activity.
     * <p>
     * See the Android Training lesson <a href=
     * "http://developer.android.com/training/basics/fragments/communicating.html"
     * >Communicating with Other Fragments</a> for more information.
     */
    public interface OnFragmentInteractionListener {
        // TODO: Update argument type and name
        void onFragmentInteraction(Uri uri);
        void setSecondHeader();
    }
}
