package com.koucky.petr.mysldenik.fragments;

import android.content.ActivityNotFoundException;
import android.content.Context;
import android.content.Intent;
import android.net.Uri;
import android.os.Bundle;
import android.os.Environment;
import android.support.annotation.NonNull;
import android.support.v4.app.Fragment;
import android.support.v4.content.ContextCompat;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ProgressBar;
import android.widget.Toast;

import com.google.android.gms.tasks.OnFailureListener;
import com.google.android.gms.tasks.OnSuccessListener;
import com.google.firebase.storage.FirebaseStorage;
import com.koucky.petr.mysldenik.MainActivity;
import com.koucky.petr.mysldenik.R;

import java.io.File;
import java.io.FileOutputStream;

import static android.Manifest.permission.WRITE_EXTERNAL_STORAGE;
import static android.content.pm.PackageManager.PERMISSION_GRANTED;


/**
 * A simple {@link Fragment} subclass.
 * Activities that contain this fragment must implement the
 * {@link PlansFragment.OnFragmentInteractionListener} interface
 * to handle interaction events.
 * Use the {@link PlansFragment#newInstance} factory method to
 * create an instance of this fragment.
 */
public class PlansFragment extends Fragment {
    // TODO: Rename parameter arguments, choose names that match
    // the fragment initialization parameters, e.g. ARG_ITEM_NUMBER
    private static final String ARG_PARAM1 = "param1";
    private static final String ARG_PARAM2 = "param2";
    private static final int MY_PERMISSIONS_REQUEST_WRITE_STORAGE = 53;

    // TODO: Rename and change types of parameters
    private String mParam1;
    private String mParam2;

    private String planUrl;
    private boolean disablePdfView = false;

    private FirebaseStorage storage;

    private OnFragmentInteractionListener mListener;
    public PlansFragment() {
        // Required empty public constructor
    }

    /**
     * Use this factory method to create a new instance of
     * this fragment using the provided parameters.
     *
     * @param param1 Parameter 1.
     * @param param2 Parameter 2.
     * @return A new instance of fragment PlansFragment.
     */
    // TODO: Rename and change types and number of parameters
    public static PlansFragment newInstance(String param1, String param2) {
        PlansFragment fragment = new PlansFragment();
        Bundle args = new Bundle();
        args.putString(ARG_PARAM1, param1);
        args.putString(ARG_PARAM2, param2);
        fragment.setArguments(args);
        return fragment;
    }

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        storage = FirebaseStorage.getInstance();

        if (getArguments() != null) {
            mParam1 = getArguments().getString(ARG_PARAM1);
            mParam2 = getArguments().getString(ARG_PARAM2);
        }

    }

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {
        // Inflate the layout for this fragment
        View view = inflater.inflate(R.layout.fragment_plans, container, false);
        System.out.println("jsem hotov");

        view.findViewById(R.id.planDeer).setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                checkPermissionToGetFile("plansDeer");
            }
        });

        view.findViewById(R.id.planShort).setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                checkPermissionToGetFile("plansSmall");
            }
        });

        view.findViewById(R.id.planOthers).setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                checkPermissionToGetFile("plansOthers");
            }
        });

        view.findViewById(R.id.planCare).setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                checkPermissionToGetFile("plansCare");
            }
        });

        view.findViewById(R.id.planDogs).setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                checkPermissionToGetFile("plansDogs");
            }
        });

        view.findViewById(R.id.planShareHunts).setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                checkPermissionToGetFile("plansHunts");
            }
        });

        view.findViewById(R.id.planCounts).setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                checkPermissionToGetFile("plansCounts");
            }
        });

        return view;
    }

    // TODO: Rename method, update argument and hook method into UI event
    public void onButtonPressed(Uri uri) {
        if (mListener != null) {
            mListener.onFragmentInteraction(uri);
        }
    }

    @Override
    public void onAttach(Context context) {
        super.onAttach(context);
        if (context instanceof OnFragmentInteractionListener) {
            mListener = (OnFragmentInteractionListener) context;
        } else {
            throw new RuntimeException(context.toString()
                    + " must implement OnFragmentInteractionListener");
        }
    }

    @Override
    public void onDetach() {
        super.onDetach();
        mListener = null;
    }

    /**
     * This interface must be implemented by activities that contain this
     * fragment to allow an interaction in this fragment to be communicated
     * to the activity and potentially other fragments contained in that
     * activity.
     * <p>
     * See the Android Training lesson <a href=
     * "http://developer.android.com/training/basics/fragments/communicating.html"
     * >Communicating with Other Fragments</a> for more information.
     */
    public interface OnFragmentInteractionListener {
        // TODO: Update argument type and name
        void onFragmentInteraction(Uri uri);
    }

    private void checkPermissionToGetFile(String fileName) {
        ((MainActivity)getActivity()).getProgressBar().setVisibility(View.VISIBLE);
        if (!disablePdfView) {
            planUrl = fileName;
            disablePdfView = true;
            int permissionCheck = ContextCompat.checkSelfPermission(getActivity(),
                    WRITE_EXTERNAL_STORAGE);

            if (permissionCheck == PERMISSION_GRANTED) {
                getPdfFile();
            } else {
                ((MainActivity) getActivity()).checkPermissionForStorage();
            }
        } else {
            Toast.makeText(getActivity().getApplicationContext(), getString(R.string.waitForPDF), Toast.LENGTH_SHORT).show();
        }
    }

    public void getPdfFile() {


        final long ONE_MEGABYTE = 4096 * 4096;
        System.out.println("docs/" + ((MainActivity) getActivity()).getUid() + "/"
                + ((MainActivity) getActivity()).getShooting() + "/"
                + ((MainActivity) getActivity()).getYear() + "/"
                + planUrl + ".pdf");
        storage.getReference().child("docs/" + ((MainActivity) getActivity()).getUid() + "/"
                + ((MainActivity) getActivity()).getShooting() + "/"
                + ((MainActivity) getActivity()).getYear() + "/"
                + planUrl + ".pdf").getBytes(ONE_MEGABYTE)
            .addOnSuccessListener(new OnSuccessListener<byte[]>() {
                @Override
                public void onSuccess(byte[] bytes) {
                    File file = prepareFile(bytes);
                    Intent target = new Intent(Intent.ACTION_VIEW);
                    target.setDataAndType(Uri.fromFile(file), "application/pdf");
                    target.setFlags(Intent.FLAG_ACTIVITY_NO_HISTORY);
                    ((MainActivity)getActivity()).getProgressBar().setVisibility(View.INVISIBLE);
                    Intent intent = Intent.createChooser(target, "Open File");
                    try {
                        disablePdfView = false;
                        startActivity(intent);
                    } catch (ActivityNotFoundException e) {
                        disablePdfView = false;
                    }

                    // Got the download URL for 'users/me/profile.png'
                    //                System.out.println("jsem hotov");
                    //                System.out.println(Arrays.toString(bytes));
                    //                PDFView pdfView = (PDFView) getView().findViewById(R.id.pdfView);
                    //                pdfView.fromBytes(bytes);
                    //TODO: Budu to zobrazovat jako novej intent proste. Tabulka odkazu a je to.
                }
            }).addOnFailureListener(new OnFailureListener() {
                @Override
                public void onFailure(@NonNull Exception exception) {
                    disablePdfView = false;
                    ((MainActivity)getActivity()).getProgressBar().setVisibility(View.INVISIBLE);
                    Toast.makeText(getActivity().getApplicationContext(), getString(R.string.planNotFound), Toast.LENGTH_SHORT).show();
                }
            });
    }

    private File prepareFile(byte[] pdf) {
        File plan = new File(Environment.getExternalStorageDirectory(), "plan.pdf");

        if (plan.exists()) {
            plan.delete();
        }

        try {
            FileOutputStream fos = new FileOutputStream(plan.getPath());
            fos.write(pdf);
            fos.close();
        }
        catch (java.io.IOException e) {
            System.out.println(e.getMessage());
        }

        return(plan);
    }

}
